import exercice_1
import exercice_3
import random

def melanger_tableau( t ):
    """
    Mélange les cartes d'un paquet.
    
    Complexité : O(n)
    """
    for i in range( len(t) ):
        v = random.randint( i, len(t)-1 )
        exercice_3.echanger( t, i, v )

def tri_singe( t ):
    """
    Tri le tableau en utilisant l'algorithme du tri radix.
    
    Complexité :
        pire cas : Infini  (l'algorithme ne se termine jamais)
        meilleur cas : Omega(n)
        
        Complexité en moyene : O( n.n! )
            Cette algorithme à une complexité HORRIBLE !

        où n = len( t )

    Exemples:
        >>> T = [3432, 2341, 32232, 4344, 43322, 4323, 2316, 2322]
        >>> tri_singe( T )
        >>> T
        [2316, 2322, 2341, 3432, 4323, 4344, 32232, 43322]
        >>> T = []
        >>> tri_singe( T )
        >>> T
        []
        >>> T = [3]
        >>> tri_singe( T )
        >>> T
        [3]
        >>> T = [3, 1]
        >>> tri_singe( T )
        >>> T
        [1, 3]
        >>> T = [1, 3]
        >>> tri_singe( T )
        >>> T
        [1, 3]

    """
    while not exercice_1.est_trie( t ):
        melanger_tableau( t )

if __name__ == "__main__":
    import doctest
    doctest.testmod() 
